#include "Fahrzeug.h"

#include <iostream>
#include <string>
#include <iomanip>
using namespace std;

#define TAKT 0.25 //Laenge eines Zeittaktes in Stunden

// globale Deklarationen
int Fahrzeug::p_iMaxID = 0;
double dGlobaleZeit = 0.0;

void vTabellenKopf() //gibt den formatierten Kopf einer Fahrzeugtabelle aus
{
	cout << setw(4) << setiosflags(ios::left) << "ID" 
		<<  setw(15) << "Name" 
		<< setw(3) << ":" 
		<< resetiosflags(ios::left) << setiosflags(ios::right) << setw(10) << "VMax (km/h)"
		<< setw(10) << "ODT (km)" << endl << resetiosflags(ios::right)
		<< "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" << endl;
}

void vAufgabe_1()
{
	string sEingabe = "";

	//erzeuge einige Fahrzeuge
	Fahrzeug faAuto1;
	Fahrzeug faAuto2("Auto 1");
	Fahrzeug faAuto3;
	Fahrzeug faAuto4("PKW 2");
	Fahrzeug faAuto8("Opel Corsa", 100.0);
	Fahrzeug faAuto9("BMW M5", 305.0);
	Fahrzeug faAuto10("Mofa", 25.8);

	//erzeuge interaktiv drei dynamische Fahrzeuge
	cout << "Geben Sie nacheinander 3 Namen fuer Fahrzeuge ein, zwischendurch ENTER druecken."
		<< endl;	
	cin >> sEingabe; Fahrzeug* ptAuto5 = new Fahrzeug(sEingabe);
	cin >> sEingabe; Fahrzeug* ptAuto6 = new Fahrzeug(sEingabe);
	cin >> sEingabe; Fahrzeug* ptAuto7 = new Fahrzeug(sEingabe);

	//gib alle bekannten Fahrzeuge aus:
	vTabellenKopf();
	faAuto1.vAusgabe(); faAuto2.vAusgabe(); faAuto3.vAusgabe(); faAuto4.vAusgabe();
	ptAuto5->vAusgabe(); ptAuto6->vAusgabe(); ptAuto7->vAusgabe();

	faAuto8.vAusgabe(); //faAuto8,9,10 haben VMax != 0...
	faAuto9.vAusgabe();
	faAuto10.vAusgabe();

	//5 Zeitschritte lang simulieren...
	cout << "Start der Simulation: " << endl << endl;
	for(int i=0; i <= 5; i++)
	{
		cout << i << ". Takt, nach " << (double)i * TAKT << " Stunden." << endl;
		// Abfertigen
		faAuto8.vAbfertigung();
		faAuto8.vAbfertigung(); //testen, ob die doppelte Abfertigung abgefangen wird
		faAuto9.vAbfertigung();
		faAuto10.vAbfertigung();
		// Ausgabe
		vTabellenKopf();
		faAuto8.vAusgabe();
		faAuto9.vAusgabe();
		faAuto10.vAusgabe();
		cout << endl;

		dGlobaleZeit += TAKT;
	}
	
	//garbage collection
	delete ptAuto6;
	delete ptAuto7;
	delete ptAuto5;
}

void vAufgabe_1_deb()
{
	Fahrzeug* aAutoListe[4];
	for (int i = 0; i<=3; i++) //erzeuge 4 simple Fahrzeuge
	{
		aAutoListe[i] = new Fahrzeug("Testmobil", 50.0);
	}

	//HIER BAUEN WIR EINEN FEHLER EIN DEN WIR MIT DEM DEBUGGER FINDEN WOLLEN...
	//aAutoListe[2] = 0;

	vTabellenKopf();
	for (int i = 0; i<=3; i++) //gib die Fahrzeuge aus
	{
		aAutoListe[i]->vAusgabe();
	}

	for (int i = 0; i<=3; i++) //garbage collection
	{
		delete aAutoListe[i];
	}
/*Wenn aAutoListe[2].vAusgabe() aufgerufen wird, dann schreit der Debugger weil auf eine
geschuetzte Speicherzelle (0x0000038) zugegriffen werden soll. Dies geschieht, weil der
Zeiger vorher umgesetzt wurde.
*/
}

void main()
{
	vAufgabe_1();
	//vAufgabe_1_deb();
	cout << "-PROGRAMMENDE-" << endl;
}
//(C) MG, WiSe 2011/2012