#pragma once
#include "aktivesvo.h"
#include <list>

#include <string>
using namespace std;

class Fahrzeug;
enum Begrenzung {Innerorts = 50, Landstrae = 100, Autobahn};

class Weg :
	public AktivesVO
{
public:
	Weg(string sIniName, double dIniLaenge, Begrenzung eIniLimit = Autobahn); //erweiterter Konstruktor
	virtual ~Weg(void);

	ostream& ostreamAusgabe(ostream& ostreamrefZiel);
	void vAbfertigung(void);
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug);
	void vAnnahme(Fahrzeug* pAufnehmFahrzeug, double dIniStartZeit);

	//Get-Funktionen
	double dGetLaenge(void){return p_dLaenge;}
	double dGetLimit(void){return p_eLimit;}
	
private:
	Weg(void); //Standardkonstruktor, unnoetig

	double p_dLaenge;				//Weglaenge in km
	list<Fahrzeug*> p_pFahrzeuge;	//Liste der auf dem Weg befindlichen Fahrzeuge
	Begrenzung p_eLimit;			//Geschwindigkeitsbegrenzung
};
//(C) MG, WiSe 2011/2012
