#pragma once
#include "aktivesvo.h"
#include "Weg.h"
#include <list>

#include <string>
using namespace std;

class Fahrzeug;
class PKW;
class Fahrrad;
//class Weg;
//enum Begrenzung;

class Kreuzung :
	public AktivesVO
{
public:
	Kreuzung(string sIniName, double dTankVolumen = 0.0);
	virtual ~Kreuzung(void);

	ostream& ostreamAusgabe(ostream& ostreamrefZiel); //ruft die Ausgaben aller der Krzg bekannten Wege auf
	void vTanken(Fahrzeug* pFarzeug); //tankt das uebergebene Fahrzeug voll
	void vVerbinde( //verbindet zwei Kreuzungen mit je einem Hin- und Rueckweg
		string sHinwegName,				//Name des Hinweges
		string sRueckwegName,			//Name des Rueckweges
		double dWegLaenge,				//Laenge der beiden Wege
		Kreuzung* pZiel,				//Zeiger auf die Kreuzung, die angebunden werden soll
		Begrenzung eLimit = Autobahn,	//Begrenzung auf den beiden Wegen
		bool Ueberholverbot = true);	//Ueberholverbot dort

	void vMacheWegBekannt(Weg* pNeuerWeg); //fuegt der Liste p_pAusgehendeWege einen neuen Weg hinzu
	void vAnnahme(Fahrzeug* pNeuesFahrzeug, double dStartZeit); //nimmt ein parkendes Fzg an und setzt es auf den ersten Weg
	void vAbfertigung(void);
	Weg* ptZufaelligerWeg(Weg* pHinweg); //gibt einen random Weg != pRueckweg zurueck, wenn es mehr als nur den Rueckweg gibt, sonst nur den Rueckweg.
	
	double dGetTankstelle(void){return p_dTankstelle;}
private:
	Kreuzung(void); //nutzloser Standardkonstruktor

	double p_dTankstelle;			//speichert, wie viele Liter Kraftstoff noch abegegben werden koennen
	list<Weg*> p_pAusgehendeWege;	//eine Liste aller abgehenden Wege

};
//by Martin Gritzan, im Rahmen des IF2-Praktikums WiSe 2011/2012