#include "Streckenende.h"
#include "Fahrzeug.h"
#include "Weg.h"
#include "Kreuzung.h"

#include <iostream>
#include <iomanip>
using namespace std;

Streckenende::Streckenende(Fahrzeug* pIniFahrzeug, Weg* pIniWeg)
	:FahrAusnahme(pIniFahrzeug, pIniWeg){}

Streckenende::Streckenende(void){}
Streckenende::~Streckenende(void){}

void Streckenende::vBearbeiten(void)
{
	//cout << p_pAusnFahrzeug->sGetName() << " auf " << p_pAusnWeg->sGetName() << " hat die Ausnahme STRECKENENDE geworfen." << endl;

	p_pAusnWeg->vAbgabe(p_pAusnFahrzeug);

	Weg* pWeitererWeg = p_pAusnWeg->pGetEndKreuzung()->ptZufaelligerWeg(p_pAusnWeg); // weiteren Weg bestimmen
	p_pAusnWeg->pGetEndKreuzung()->vTanken(p_pAusnFahrzeug); // Fahrzeug betanken
	pWeitererWeg->vAnnahme(p_pAusnFahrzeug); //Fahrzeug auf neuen Weg setzen
	
	//Ausgabe der Uebergabe
	cout << setiosflags(ios::left) 
		<< setw(10) << "ZEIT" << setw(3) << " : " << setw(10) << dGlobaleZeit << endl
		<< setw(10) << "KREUZUNG" << setw(3) << " : " << p_pAusnWeg->pGetEndKreuzung()->sGetName()
		<< " (Tankstelle: Noch " << resetiosflags(ios::left) << setiosflags(ios::fixed) << setbase(10) << setprecision(2) 
		<< p_pAusnWeg->pGetEndKreuzung()->dGetTankstelle() << " Liter)" << endl 
		<< setiosflags(ios::left) << resetiosflags(ios::fixed)
		<< setw(10) << "WECHSEL" << setw(3) << " : " << p_pAusnWeg->sGetName() << " -> " << pWeitererWeg->sGetName() << endl
		<< setw(10) << "FAHRZEUG" << setw(3) << " : " << setw(10) << p_pAusnFahrzeug->sGetName()
		<< resetiosflags(ios::left) << endl;
}
//(C) MG, WiSe 2011/2012