#pragma once

#include <string>
using namespace std;

class Fahrzeug
{
public:
	//Funktionen
	Fahrzeug(void);
	Fahrzeug(string sIniName);
	Fahrzeug(string sIniName, double dVMax); //die drei Konstruktoren
	virtual ~Fahrzeug(void);

	void vAusgabe(void); //Ausgabefunktion
	void vAbfertigung(void); //Abfertigungsfunktion

private:
	//Funktionen
	void vInitialisierung(void);
	//Variablen
	string p_sName;					//Name des Fahrzeugs
	int p_iID;						//eideutige ID
	double p_dMaxGeschwindigkeit;	//technische Hoechstgeschwindigkeit des Fahrzeugs
	double p_dGesamtStrecke;		//Tachostand des Fahrzeugs
	double p_dZeit;					//Zeit, zu der das Fahrzeug zuletzt abgefertigt wurde
	//statische Variablen
	static int p_iMaxID;			//globales Maximum der vergebenen IDs
	
};
//(C) MG, WiSe 2011/2012
