#pragma once
#include "fahrzeug.h"

#include <string>
using namespace std;

class FzgVerhalten;

class PKW :
	public Fahrzeug
{
public:
	//erweiterter Konstruktor, benutzt den allgemeinen Konstruktor der Vaterklasse
	PKW(string sIniName, double dVMax, double dConsumption, double dTCapacity = 55.0);
	virtual ~PKW(void);

	double dVerbrauch(void) const; //ermittelt den bisherigen Gesamtverbrauch
	double dTanken(double dMenge = 0.0); //fuellt den Tank des PKW auf, default ist Volltanken
	void vAusgabe(void) const;
	ostream& ostreamAusgabe(ostream& ostreamrefZiel);
	void vAbfertigung(void);

	double dGeschwindigkeit(void) const;

private:
	PKW(void); //Standardkonstruktor, wird nicht verwendet

	double p_dVerbrauch; //Verbrach in l/100km
	double p_dTankinhalt; //Tankinhalt in l
	double p_dTankvolumen; //Tankvolumen in l
	
};
//(C) MG, WiSe 2011/2012
