#pragma once

#include <string>
using namespace std;

class AktivesVO
{
public:
	AktivesVO(void);
	virtual ~AktivesVO(void);

	virtual ostream& ostreamAusgabe(ostream& ostreamrefZiel); //Ausgabefunktion
	virtual void vAbfertigung(void) = 0; //rein virtuelle Abfertigungsmethode

	string sGetName(void) const {return p_sName;}

protected:
	//Variablen
	string p_sName;					//Name des VOs
	int p_iID;						//eideutige ID
	double p_dZeit;					//Zeit, zu der das VO zuletzt abgefertigt wurde
	//statische Variablen
	static int p_iMaxID;

private:
	void vInitialisierung(void);
};

ostream& operator<<(ostream& ostreamrefZiel, AktivesVO& fahrzeugrefObjekt);
//(C) MG, WiSe 2011/2012