#include "Fahrrad.h"
#include "SimuClient.h"
#include "FzgVerhalten.h"
#include "Weg.h"
#include <math.h>

#include <string>
#include <iostream>
#include <iomanip>
using namespace std;

#define EPSILON 0.0166 //ca. 1 Minute wenn die Zeit in Stunden gemessen wird

extern double dGlobaleZeit;

//################ Konstruktoren, Destruktor #######################
Fahrrad::Fahrrad(void)
{
}

Fahrrad::Fahrrad(string sIniName, double dVMax) : Fahrzeug(sIniName, dVMax) {};

Fahrrad::~Fahrrad(void)
{
}

//################ Wirkfunktionen ###################################
void Fahrrad::vAusgabe(void) const
{
	Fahrzeug::vAusgabe();
}

ostream& Fahrrad::ostreamAusgabe(ostream& ostreamrefZiel)
{
	//ostreamrefZiel = Fahrzeug::ostreamAusgabe(ostreamrefZiel);
	//return ostreamrefZiel;
	return Fahrzeug::ostreamAusgabe(ostreamrefZiel);
}

void Fahrrad::vAbfertigung(void)
{
	if(fabs(dGlobaleZeit - p_dZeit) > EPSILON) Fahrzeug::vAbfertigung();
}

double Fahrrad::dGeschwindigkeit(void) const
{
	/* v nach x km berechnet sich mit v = vMax * 0,9^(untere Gaussklammer(x/20)) */
	double dAktGeschwind = p_dMaxGeschwindigkeit * (pow(0.9,(int)(p_dGesamtStrecke/20)));
	//noch groesser als 12km/h?
	if(dAktGeschwind >= 12.0) return dAktGeschwind;
	else return 12.0;
	
}

void Fahrrad::vZeichnen(Weg* pIniWeg)
{
	bZeichneFahrrad(p_sName, //Fahrzeugname
		pIniWeg->sGetName(), //Wegname
		p_dAbschnittStrecke / pIniWeg->dGetLaenge(), //Fortschritt auf dem Weg in %
		dGeschwindigkeit());
}

double Fahrrad::dTanken(double dMenge){return 0.0;} //Fahrraeder tanken nicht...
//(C) MG, WiSe 2011/2012