#include "FzgParken.h"
#include "Fahrzeug.h"
#include "Weg.h"
#include "Losfahren.h"

extern double dGlobaleZeit;

//############################ Kostruktoren, Destruktor ################################
FzgParken::FzgParken(Weg* pIniWeg, double dIniStartZeit)
	:FzgVerhalten(pIniWeg)
{
	p_dStartZeit = dIniStartZeit;
}
FzgParken::FzgParken(void){}
FzgParken::~FzgParken(void){}

//############################ Wirkfunktionen ##########################################
double FzgParken::dStrecke(Fahrzeug* pFahrzeug, double dZeitvorgabe) const
{
	if(dGlobaleZeit < p_dStartZeit)
		return 0.0;
	else
		throw new Losfahren(pFahrzeug, p_pAktuellerWeg);
}
//(C) MG, WiSe 2011/2012